#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <string.h>
#include "typedefs.h"

/*  */
#define SYNTH_PORT             PORTB
#define SYNTH_PORT_DIR         DDRB     //  ATtiny45 |  /  LM7001
#define SYNTH_PIN_CE           PB2      //      pin 7      |           pin 3
#define SYNTH_PIN_CLK          PB0      //      pin 5      |           pin 4
#define SYNTH_PIN_DATA         PB4      //      pin 3      |           pin 5

#define SND_PORT      PORTB
#define SND_PORT_DIR  DDRB
#define PIN_OC1       PB1               //      pin 6

/*   */
void IOInit(void);
void InitSynthPins(void);
void nop(void);
void SetCLKLow(void);
void SetCLKHigh(void);
void SetDataLow(void);
void SetDataHigh(void);
void SetCELow(void);
void SetCEHigh();

void PWMInit(void);
void Wait_us(UINT16 delay);
void Wait_ms(UINT16 delay);

void lcd_set_strobe(void);
void lcd_clr_strobe(void);
void lcd_set_command(void);
void lcd_set_data(void);

void lcd_write(UINT8 value, UINT8 cd);
void lcd_write_data(UINT8 data);
void lcd_write_cmd(UINT8 cmd);

void LCD_print_str(char *text);
void LCD_hex_print_16(INT16 value);
void LCD_hex_print_32(INT32 value);
void LCD_print_hex_byte(UINT8 byte);
void LCD_print_dec(UINT32 ciffer);

void InitLCDPins(void);
void send_word(UINT32);

//     FT ( )
#define MORSE_FREQUENCY_STEP (UINT8)((2048UL*FT/(F_CPU/510UL))+0.5)

//     
#define     MORSE_COEFF_DASH             3.2

// 
#define     SPACE                        0x20

//  
#define     EXCLAMATION_MARK             0x21

//     
#define     MORSE_DOT_LENGTH             1600

//    ,    
#define     MORSE_DASH_LENGTH            MORSE_COEFF_DASH*MORSE_DOT_LENGTH

//   
#define     MORSE_PAUSE_WITHIN_SIGN      MORSE_DOT_LENGTH

//  
#define     MORSE_PAUSE_BETWEEN_SIGNES   MORSE_DASH_LENGTH

//    
#define     MORSE_PAUSE_BETWEEN_WORDS    MORSE_COEFF_DASH*MORSE_DASH_LENGTH

#define nop() __asm__ volatile("nop");
